try {
    template.config('openTag', '<?');
    template.config('closeTag', '?>');
    template.helper('console', console);
    template.helper('jsonparse', JSON.parse);
    template.helper('getPrice', getPrice);
    template.helper('formatDate', formatDate);
} catch (e) {

}

var userAgent = window.navigator.userAgent.toLowerCase();
var isMuCang = userAgent.indexOf('mucang') > -1;
var isAndroid = userAgent.indexOf('android') > -1;
var isIOS = userAgent.indexOf('iphone') > -1;
var host = 'http://sirius.ttt.mucang.cn';

Date.prototype.format = function (fmt) { //author: meizz
    var o = {
        "M+": this.getMonth() + 1, //月份
        "d+": this.getDate(), //日
        "h+": this.getHours(), //小时
        "m+": this.getMinutes(), //分
        "s+": this.getSeconds(), //秒
        "q+": Math.floor((this.getMonth() + 3) / 3), //季度
        "S": this.getMilliseconds() //毫秒
    };
    if (/(y+)/.test(fmt)) fmt = fmt.replace(RegExp.$1, (this.getFullYear() + "").substr(4 - RegExp.$1.length));
    for (var k in o)
        if (new RegExp("(" + k + ")").test(fmt)) fmt = fmt.replace(RegExp.$1, (RegExp.$1.length == 1) ? (o[k]) : (("00" + o[k]).substr(("" + o[k]).length)));
    return fmt;
}

function formatDate(date, fmt) {
    if (typeof date == 'object') {
        return date.format(fmt);
    } else {
        return new Date(date).format(fmt);
    }

}

var isIdentityNumber = function (val) {
    if (/^[1-9]\d{7}((0\d)|(1[0-2]))(([0|1|2]\d)|3[0-1])\d{3}$|^[1-9]\d{5}[1-9]\d{3}((0\d)|(1[0-2]))(([0|1|2]\d)|3[0-1])\d{3}([0-9]|X)$/.test(val)) {
        return true;
    }
    return false;
}

var isRealName = function (val) {
    if (/^[\u4e00-\u9fa5]{2,}$/g.test(val)) {
        return true;
    }
    return false;
}

var isRealPhone = function (val) {
    if (/^1\d{10}$/.test(val)) {
        return true;
    }
    return false;
}

function goBack(close) {
    if (isMuCang) {
        if (close) {
            webview.web.close();
        } else {
            // if (isAndroid) {
            history.back();
            // } else if (isIOS) {
            //     webview.web.back();
            // }
        }

    } else {
        history.back();
    }
}

function saveData(obj) {
    if (typeof obj.value == 'object') {
        obj.value = JSON.stringify(obj.value);
    }
    if (isMuCang) {
        // window.mcJSBridge.callFn('core', 'system/setcache',obj, function (data) {
        //     alert(JSON.stringify(data))
        //     callback && callback((data && data.value || ''));
        // })
        window.webview.system.setcache(obj, function (data) {

        });
    } else {
        window.localStorage.setItem(obj.key, obj.value)
    }
}

function getData(key, callback) {
    if (isMuCang) {
        // window.mcJSBridge.callFn('core', 'system/getcache',{key: key}, function (data) {
        //     alert(JSON.stringify(data))
        //     callback && callback((data && data.value || ''));
        // })
        window.webview.system.getcache({key: key}, function (data) {
            callback && callback((data && data.value || ''));
        });
    } else {
        callback && callback(window.localStorage.getItem(key));
    }
}

function getSystemInfo(callback) {
    if (isMuCang) {
        webview.system.info(function (baseParams) {
            if (baseParams.data) {
                if (typeof baseParams.data == 'string') {
                    baseParams = JSON.parse(baseParams.data);
                } else {
                    baseParams = baseParams.data;
                }
                callback(baseParams);
            } else {
                if (typeof baseParams == 'string') {
                    baseParams = JSON.parse(baseParams);
                } else {
                    baseParams = baseParams;
                }
                callback(baseParams);
            }
        })
    } else {
        callback({_version: ''});
    }
}

function getAuthToken(callback) {
    var authToken = getSearch('authToken');
    if (authToken && authToken != 'undefined') {
        callback && callback(authToken);
    } else {
        if (isMuCang) {
            setTimeout(function () {
                webview.user.get(function (data) {
                    if (data.success.toString() === 'true') {
                        authToken = data.data.authToken;
                    } else {
                        authToken = '';
                    }
                    callback && callback(authToken);
                })
            }, 300)
        } else {
            callback && callback('');
        }
    }
}

function request(url, params, callback, isWeb) {
    getAuthToken(function (authToken) {
        params = params || {};
        if (authToken) {
            params.authToken = authToken;
        }
        if (isMuCang && !isWeb) {
            setTimeout(function () {
                window.webview.http.get(host + url, {
                    callback: function (data) {
                        callback(data);
                    },
                    header: {
                        "X-Data-Token": "token"
                    },
                    sign: '*#06#c2uXpo9IeKaIkpyJdXipfGxs',
                    params: params
                });
            }, 300)

        } else if (isMuCang && isWeb) {
            webview.system.info(function (baseParams) {
                if(baseParams.data){
                    if(typeof baseParams.data == 'string'){
                        baseParams= JSON.parse(baseParams.data);
                    }else{
                        baseParams = baseParams.data;
                    }
                }
                params = $.extend(params, baseParams);
                $.ajax({
                    url: host + url,
                    dataType: 'json',
                    type: 'get',
                    data: params,
                    success: function (data) {
                        callback({
                            success: data.success,
                            data: data.data,
                            message: data.message,
                            errorCode: data.errorCode
                        })
                    },
                    error: function () {
                        callback({
                            success: false,
                            message: '网络连接失败'
                        })
                    }
                })
            })
        } else {
            params.resign = 'hello';
            $.ajax({
                url: host + url,
                dataType: 'json',
                type: 'get',
                data: params,
                success: function (data) {
                    callback({
                        success: data.success,
                        data: data.data,
                        message: data.message,
                        errorCode: data.errorCode
                    })
                },
                error: function () {
                    callback({
                        success: false,
                        message: '网络连接失败'
                    })
                }
            })
        }
    })

}

function getPrice(price) {
    if (price) {
        return parseFloat((price / 100).toFixed(2));
    } else {
        return '';
    }
}

function toast(message) {
    if (isMuCang) {
        webview.system.toast(message);
    } else {
        var oToast = $('<div class="toast">' + (message || '') + '</div>');
        $(document.body).append(oToast);
        setTimeout(function () {
            oToast.addClass('show');
        }, 10);
        setTimeout(function () {
            oToast.removeClass('show').addClass('hide');
            setTimeout(function () {
                oToast.remove();
            }, 200);
        }, 1000);
    }
}

function split(text, lineSplitter, fieldSplitter) {
    var list = {};
    if (text) {
        lineSplitter = lineSplitter || "\n";
        fieldSplitter = fieldSplitter || "\t";
        var pairs = text.split(lineSplitter);
        for (var i = 0; i < pairs.length; i++) {
            var parts = pairs[i].split(fieldSplitter);
            var keyname = parts[0], keyvalue = parts[1];
            if (typeof list[keyname] === "undefined") {
                list[keyname] = keyvalue;
            } else if (typeof list[keyname] === "string") {
                var arr = [list[keyname], keyvalue];
                list[keyname] = arr;
            } else {
                list[keyname].push(keyvalue);
            }
        }
    }
    return list;
}

function getSearch(key) {
    return decodeURIComponent(searchParams()[key]);
}

function searchParams() {
    return split(window.location.search.replace(/^\?/ig, ''), '&', '=');
}