$(function () {
    FastClick.attach(document.body);

    // status: 0: 未购买  10： 已过期  100： 已购买
    var urlParams = searchParams();


    var orderObj = {
        sessionIds: '',
        tiku: urlParams.carStyle,
        payType: '1'
    };

    var payChannel = {
        1: 'alipay_mobile',
        2: 'weixin_mobile'
    };

    var kemu = urlParams.kemuStyle || 1;
    var passTime = urlParams.passTime || -2;
    if (kemu == 'kemu1') {
        kemu = 1;
    } else if (kemu == 'kemu2') {
        kemu = 2;
    } else if (kemu == 'kemu3') {
        kemu = 3;
    } else if (kemu == 'kemu4') {
        kemu = 4;
    }
    urlParams.kemuStyle = kemu;

    var groupSeesionKey = {
        'group_1': ['session-elite'],
        'group_2': ['session-kemu1-kemu4', 'session-kemu1', 'session-kemu4']
    }
    var groupSessionData, distinctSessionData;

    function setTitle(kemu) {
        var title = '';
        switch (kemu) {
            case 1:
                title = '科目一VIP服务';
                break;
            case 4:
                title = '科目四VIP服务';
                break;
        }
        $('.offline-title').text(title);
    }

    // setTitle(kemu);

    function setPassRateObj(passTime) {
        var obj = {
            rate: '',
            text: ''
        }
        if (passTime == 0) {
            obj.rate = '--';
            obj.text = '您还未做过任何练习和模拟考试，小编不能掐指一算';
        } else if (passTime == -2) {
            //用来判断是否传了passTime参数，方便调试
            obj.rate = '11.0%';
            obj.text = '您的通过率太低了，要使出洪荒之力才能通过考试，去上课吧';
        } else if (passTime == -1) {
            obj.rate = '10.0%';
            obj.text = '您的通过率太低了，要使出洪荒之力才能通过考试，去上课吧';
        } else if (passTime == 1) {
            obj.rate = '31.3%';
            obj.text = '您离成功还差4次模拟考，去上课考试吧';
        } else if (passTime == 2) {
            obj.rate = '42.1%';
            obj.text = '您离成功还差3次模拟考，去上课考试吧';
        } else if (passTime == 3) {
            obj.rate = '64.7%';
            obj.text = '您离成功还差2次模拟考，去上课考试吧';
        } else if (passTime == 4) {
            obj.rate = '75.3%';
            obj.text = '您离成功还差1次模拟考，去上课考试吧';
        } else if (passTime == 5) {
            obj.rate = '92.6%';
            obj.text = '恭喜您通过率达90%以上，可以安心去考试了，考前再冲刺一下更有把握哦';
        } else if (passTime == 6) {
            obj.rate = '95.8%';
            obj.text = '您还未做过任何练习和模拟考试，小编不能掐指一算';
        } else if (passTime > 6) {
            var rate = 95.8 + 0.1 * (passTime - 6);
            obj.rate = rate > 99.9 ? '99.9%' : rate.toFixed(1) + '%';
            obj.text = '恭喜您通过率达95%以上，考试正常发挥就没问题哦，预祝您通过考试';
        }
        $('.pass-rate-val').text(obj.rate);
        $('.pass-rate-txt').text(obj.text);
    }

    setPassRateObj(passTime);

    var kemuMap = {
        1: '科目一',
        2: '科目二',
        3: '科目三',
        4: '科目四'
    };

    var switchKemu = 1;

    $('.switch-btn').on('click', function () {

        if (switchKemu == 1) {
            switchKemu = 4;
        } else {
            switchKemu = 1;
        }
        var switchKemuTxt = kemuMap[switchKemu];
        $('.switch-kemu').text(switchKemuTxt);
        switchKemuProtocol();
        saveData({
            key: 'switch-kemu',
            value: switchKemu
        });
    });

    function getVersionNum(version) {
        var tmp1 = version.split('.');
        var vLen = tmp1.length, vNum = 0;
        for (var i = 0; i < vLen; i++) {
            vNum += tmp1[i] * Math.pow(10, (vLen - i) * 2);
        }
        return vNum;
    }

    function switchKemuProtocol() {
        getSystemInfo(function (baseParams) {
            if (getVersionNum(baseParams._version) >= getVersionNum('6.8.5')) {
                window.location.href = 'http://jiakao.nav.mucang.cn/switchKemu?kemu=kemu' + switchKemu;
            }
        });
    }

    function setOriginalPrice(data) {
        var goodsEntityList = data.goodsEntityList;
        var original = 0;
        for (var j = 0; j < goodsEntityList.length; j++) {
            original += goodsEntityList[j].price;
        }
        data.originalPrice = original;
        return data;
    }

    function setGroupData(data) {
        var groupData = {data: data};
        for (var i = 0; i < data.length; i++) {
            var itemData = setOriginalPrice(data[i]);
            for (var k in groupSeesionKey) {
                if (groupSeesionKey[k].indexOf(itemData.uniqKey) > -1) {
                    if (!groupData[k]) {
                        groupData[k] = [];
                    }
                    groupData[k].push(itemData)
                }
            }
        }
        return groupData;
    }

    function setPayPrice() {
        var sessionIds = [];
        var payPrice = 0;
        $('.checked').each(function () {
            payPrice += parseFloat($(this).attr('data-price'));
            sessionIds.push($(this).attr('data-id'));
        });
        $('.pay-price').text(payPrice);
        orderObj.sessionIds = sessionIds.join(',');
    }

    function distinctSession(sessions) {
        var buyed = [], unbuyed = [];
        for (var i = 0; i < sessions.length; i++) {
            var iData = sessions[i];
            if (iData.status == 0) {
                unbuyed.push(iData);
            } else {
                buyed.push(iData);
            }
        }
        return {
            buyed: setGroupData(buyed),
            unbuyed: setGroupData(unbuyed)
        }
    }

    function getShouldReservedKemu(data) {
        var reserveKemu = [];
        for (var i = 0; i < data.length; i++) {
            var iData = data[i];
            if (iData.uniqKey == 'session-kemu1-kemu4') {
                reserveKemu = [1, 4];
            }

            if (iData.uniqKey == 'session-kemu1') {
                if (reserveKemu.indexOf(1) == -1) {
                    reserveKemu.push(1);
                }
            }

            if (iData.uniqKey == 'session-kemu4') {
                if (reserveKemu.indexOf(4) == -1) {
                    reserveKemu.push(4);
                }
            }
        }
        return reserveKemu;
    }

    function getUnreservedKemu(shouldReserveKemu, reserveData) {
        // console.log(reserveData.pop());
        var unreservedKemu = [];
        for (var i = 0; i < shouldReserveKemu.length; i++) {
            var flag = false;
            for (var j = 0; j < reserveData.length; j++) {
                if (reserveData[j].kemu == shouldReserveKemu[i]) {
                    flag = true;
                }
            }
            if (!flag) {
                unreservedKemu.push(shouldReserveKemu[i])
            }
        }
        return unreservedKemu;
    }

    setTimeout(function () {
        getData('user-goods-session-list', function (data) {
            try {
                var itemList = JSON.parse(data);
            } catch (e) {
                itemList = [];
            }
            itemList = itemList || [];
            groupSessionData = setGroupData(itemList);
            distinctSessionData = distinctSession(itemList);
            var mainHtml = template('main-tpl', {data: distinctSessionData});

            $('.main-tpl').html(mainHtml);

            $('.switch-con').removeClass('hide');
            getData('switch-kemu', function (data) {
                switchKemu = data || switchKemu;
                var switchKemuTxt = kemuMap[switchKemu];
                $('.switch-kemu').text(switchKemuTxt);
                switchKemuProtocol();
            });

        })

    }, 500)


    $('.offline-back').on('click', function () {
        goBack(true);
    });

    $('.help-back').on('click', function () {
        $('.section-help').removeClass('trans-show');
        goBack();
        // window.history.replaceState({'page': 'index'}, '', location.pathname+location.search)
    });

    $('.help-link').on('click', function () {
        window.history.pushState({'page': 'help'}, '', '../help');
        $('.section-help').addClass('trans-show');
        // window.location.href = '../help';
    });

    $(window).on('popstate', function (e) {
        if (!e.state) {
            $('.section').removeClass('trans-show');
        }
    });

    $('body').on('click', '[data-action]', function () {
        var status = $(this).attr('data-status');
        var uniqKey = $(this).attr('data-uniq');

        var actionUrl = $(this).attr('data-action');

        if (uniqKey == 'goods-zsdfl') {
            getSystemInfo(function (baseParams) {
                if (getVersionNum(baseParams._version) < getVersionNum('6.8.5')) {
                    window.mcJSBridge.callFn('core', 'system/confirm', {
                        title: '',
                        message: '此功能为新功能，请您下载最新版驾考宝典进行使用',
                        cancel: '暂不更新',
                        action: '马上更新'
                    }, function (data) {
                        if (data.data == "true" || data.data == true || data === true) {
                            window.location.href = 'http://a.app.qq.com/o/simple.jsp?pkgname=com.handsgo.jiakao.android';
                        }
                    })
                } else {
                    window.location.href = actionUrl + '?kemu=' + switchKemu + '&orgKemu=' + kemu;
                }
            })
        } else {
            window.location.href = 'http://jiakao.nav.mucang.cn/main?kemu=kemu' + switchKemu + '&extraUrl=' + encodeURIComponent(actionUrl);
        }

    });

});